﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
#Event: Ready(Success As Boolean)

Sub Class_Globals
	Private mCallBack As Object
	Private mEvent As String
	
	Private conn As Boolean
	Public MyConnection As Object
	
	Public const MsSql_String As String = "net.sourceforge.jtds.jdbc.Driver"
	Public const MySql_String As String = "com.mysql.jdbc.Driver"
	Public const PostgreSql_String As String = "org.postgresql.Driver"
	Public const MariaDB As String = "mariadb-java-client-2.4.2.jar"
	Public const OracleDB As String = "oracle.jdbc.driver.OracleDriver"
	'Public const SqliteB4J As String = "org.sqlite.JDBC"
End Sub

'Initializes the object. Insert row with #AdditionalJar
'MySQL Driver <code> #AdditionalJar: mysql-connector-java-5.1.47-bin.jar</code>
'MSSQL Driver <code> #AdditionalJar: jtds-1.3.1.jar</code>
'PostgreSQL Driver <code> #AdditionalJar: postgresql-42.2.6.jar</code>
'MariaDB Driver <code> #AdditionalJar: mariadb-java-client-2.4.2.jar</code>
'Oracle Driver <code> #AdditionalJar: ojdbc8.jar</code>
Public Sub Initialize(CallBack As Object, Event As String)
	mCallBack=CallBack
	mEvent=Event
	conn=False
End Sub

Public Sub Connect(DriverClass As String,JDBCurl As String, DBUser As String, DBPassword As String)
	Dim J As JavaObject = Me
	'J.InitializeContext
	#IF B4A
	J.RunMethod("strictmode",Null)
	#END IF
	MyConnection = J.RunMethod("connect", Array(DriverClass,JDBCurl,DBUser,DBPassword))
End Sub

' Return resultSet object
Public Sub ExecQuery(Query As String) As SD_ResultSet
	Dim J As JavaObject = Me
	'J.InitializeContext
	
	Dim rs As SD_ResultSet
	rs.Initialize(J.RunMethod("executequery", Array(Query)))
	Return rs
End Sub

Public Sub ExecQueryResutSet(Query As String) As Object
	Dim J As JavaObject = Me
	'J.InitializeContext
	Return J.RunMethod("executequery", Array(Query))
End Sub

Public Sub ExecNonQuery (Statement As String) As Boolean
	Dim J As JavaObject = Me
	'J.InitializeContext
	Dim B As Boolean= J.RunMethod("execnonquery", Array(Statement))
	Return b
End Sub

Public Sub Close
	Dim J As JavaObject = Me
	'J.InitializeContext
	J.RunMethod("close", Null)
End Sub

Public Sub connected As Boolean
	Return conn
End Sub

private Sub sql_connected
	conn=True
	If SubExists(mCallBack,mEvent & "_Ready") Then CallSubDelayed2(mCallBack,mEvent & "_Ready",True)
End Sub

Private Sub sql_notconnected
	conn=False
	If SubExists(mCallBack,mEvent & "_Ready") Then CallSubDelayed2(mCallBack,mEvent & "_Ready",False)
End Sub

#IF JAVA

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import anywheresoftware.b4a.BA.Permissions;
@Permissions(values={"android.permission.ACCESS_NETWORK_STATE","android.permission.INTERNET"})

 static Connection conn;
 static PreparedStatement st;
 static ResultSet rs;

 public Connection connect(String driverclass, String conname, String user, String password) throws SQLException {
   //ba.raiseEvent(this,EventName.toLowerCase(),result);
   try {
      Class.forName(driverclass);
    } catch (ClassNotFoundException e) {
      BA.Log("Class not found: " + driverclass + " in #AdditionalJar");
	  ba.raiseEventFromUI(null, "sql_notconnected");
    } 
  
  try
        {
    	  //Class.forName(driverclass);
		  this.conn=DriverManager.getConnection(conname,user,password);
		  BA.Log("connected");
		  ba.raiseEventFromUI(null, "sql_connected");
        }
        catch(Exception e)
        {
           e.printStackTrace();
		   BA.Log("Not connected: " + e);
		   ba.raiseEventFromUI(null, "sql_notconnected");
        }
 return conn;
 }
 
 public ResultSet executequery(String query) {

  try
        {
            st=this.conn.prepareStatement(query);
            rs=st.executeQuery();
           
        }
        catch(Exception e)
        {
           e.printStackTrace();
		   BA.Log("Query Error: " + e);
		   System.out.println("Error query");
        }
 return rs;
 }
 
 public boolean execnonquery(String TextStatement) throws SQLException {
    boolean rsl = false;
    if (this.conn == null) {
		BA.Log("Object should first be initialized."); 
    } else {
		Statement stmn = this.conn.createStatement();
		try {
      		rsl=stmn.execute(TextStatement);
    		} catch(Exception e) 
			{
				e.printStackTrace();
				BA.Log("EQ Error: " + e);
				System.out.println("Error execute");
    		} 
		//st.close();
	}
    return rsl;
  }
 
 public void close() {
 try
        {
  		//if (this.rs != null) {this.rs.close();}
        if (this.st != null) {this.st.close();}
        if (this.conn != null) {this.conn.close();}
		 }
 catch(Exception e)
        {
           e.printStackTrace();
		   System.out.println("Errore di query");
        }
		
 }
 
#End If

#IF B4A

	#IF JAVA
	 public void strictmode() {
		android.os.StrictMode.ThreadPolicy policy = new android.os.StrictMode.ThreadPolicy.Builder().permitAll().build();
		android.os.StrictMode.setThreadPolicy(policy);
	 }
	#End If

#End If
